<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2008 Shawn McKenzie
// http://www.spidean.com
// ----------------------------------------------------------------------
//
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
//
// ----------------------------------------------------------------------

function atPlatformHeader($xhtml)
{
	if (atGetModName() == "PNphpBB2") {
		$GLOBALS['additional_header'][] = "<link rel=\"stylesheet\" href=\"".$GLOBALS['board_config']['style_name']."\" type=\"text/css\""
		.($xhtml ? " />" : ">")."\n";
	}
	if (is_array($GLOBALS['additional_header'])) {
		$head = implode("\n", $GLOBALS['additional_header']);

		return $head;
	}
	return false;
}

function atPlatformThemeInit()
{
    $GLOBALS['postnuke_theme'] = true;

    if (defined('WHERE_IS_PERSO') &&
    	WHERE_IS_PERSO &&
    	@file_exists(WHERE_IS_PERSO."themes/$thename/theme.cfg"))
    {
        $multipath = WHERE_IS_PERSO;
    }
    else {
        $multipath = "";
    }
    $themeconfig = compact('multipath');

    return $themeconfig;
}

function atPlatformAPIInit()
{
    return array();
}

function atGetPlatformVersion()
{
    return _PN_VERSION_NUM;
}

function atGetHomeMod()
{
    return pnConfigGetVar('startpage');
}

function atIsHomePage()
{
    if (eregi("index.php", $_SERVER['PHP_SELF']) &&
    	!isset($_GET['module']) &&
    	!isset($_GET['name']))
    {
        return true;
    }
    else {
        return false;
    }
}

function atIsAdminUser()
{
    return pnSecAuthAction(0, '::', '::', ACCESS_ADMIN);
}

function atIsLoggedIn()
{
    return pnUserLoggedIn();
}

function atGetUserName()
{
    if (!atIsLoggedIn()) {
        if (defined('_AT_GUEST')) {
            $username = _AT_GUEST;
        }
        else {
            $username = "";
        }
    }
    else {
        $username = pnUserGetVar('uname');
    }
    return $username;
}

function atGetModType()
{
    $type = "";

    if (eregi("admin.php", $_SERVER['PHP_SELF'])) {
        $type = "admin";
    }
    elseif (eregi("index.php", $_SERVER['PHP_SELF']) && isset($_GET['type'])) {
        $type = $_GET['type'];
    }
    elseif (eregi("user.php", $_SERVER['PHP_SELF'])) {
        $type = "user";
    }
    return $type;
}

function atGetModStyle()
{
    $modname = atGetModName();
    $modinfo = pnModGetInfo(pnModGetIDFromName($modname));

    if ($modinfo['type'] != 1) {
    	if (atGetModType() == 'admin' || @file_exists("modules/".$modinfo['directory']."/pnuser.php")) {
        	$style = "new";
    	}
    	else {
    		$style = "old";
    	}
    }
    else {
        $style = "old";
    }
    return $style;
}

function atGetModName()
{
    return pnModGetName();
}

function atGetLang()
{
    return pnUserGetLang();
}

function atBlockLoad($location="", $title="")
{
	$runningconfig = atGetRunningConfig();
	$blocklist = $runningconfig['blocklist'];

    if ($location) {
    	foreach ($blocklist as $block) {
    		if ($block['position'] == $location && $block['active'] == 1) {
    			echo pnBlockShow($block['modname'], $block['bkey'], $block);
    		}
    	}
    }
    elseif ($title) {
    	if ($blocklist[$title]['active'] == 1) {
    		$block = $blocklist[$title];
    		echo pnBlockShow($block['modname'], $block['bkey'], $block);
    	}
    }
}

function atGetBlocks()
{
    list($dbconn) = pnDBGetConn();

    pnModDBInfoLoad("Blocks");
    $pntable = pnDBGetTables();

    $blockcol = &$pntable['blocks_column'];
    $poscol = &$pntable['block_placements_column'];
    $modcol = &$pntable['modules_column'];

    if (pnConfigGetVar('multilingual')) {
        $suffix = "AND ($blockcol[blanguage]='".pnVarPrepForStore(atGetLang())."' OR $blockcol[blanguage]='')";
    }
    else {
        $suffix = "";
    }
    $sql = "SELECT	$pntable[blocks].$blockcol[bid] as bid,
					$blockcol[bkey] as bkey,
					$blockcol[mid] as mid,
					$blockcol[title] as title,
					$blockcol[content] as content,
					$blockcol[url] as url,
					$poscol[pid] as position,
					$poscol[order] as weight,
					$blockcol[active] as active,
					$blockcol[refresh] as refresh,
					$blockcol[last_update] AS unix_update,
					$blockcol[blanguage] as blanguage,
					$modcol[name] as modname
			FROM	$pntable[block_placements], $pntable[blocks]
			LEFT JOIN $pntable[modules]
			ON $pntable[modules].$modcol[id] = $pntable[blocks].$blockcol[mid] 
			WHERE $pntable[block_placements].$blockcol[bid] = $pntable[blocks].$blockcol[bid] $suffix";

    $result = $dbconn->Execute($sql);

    while (!$result->EOF) {
        $block = $result->GetRowAssoc(false);
        $block['unix_update'] = $result->UnixTimeStamp($block['unix_update']);
        $block['weight'] = (int)$block['weight'];

        if (!$block['modname']) {
            $block['modname'] = "Core";
        }
        switch ($block['position']) {
            case 1:
            $block['position'] = "l";
            break;

            case 2:
            $block['position'] = "r";
            break;

            case 3:
            $block['position'] = "c";
            break;
        }
        $title = $block['title'];
        $blocklist[$title] = $block;

        $result->MoveNext();
    }
    return $blocklist;
}

function atBlockList()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $blockcol = &$pntable['blocks_column'];

    $sql = "SELECT	$blockcol[title]
    		FROM 	$pntable[blocks]
    		ORDER BY $blockcol[title]";

    $result = $dbconn->Execute($sql);

    while (list($title) = $result->fields) {
    	$blocklist[] = $title;
    	$result->MoveNext();
    }
    natcasesort($blocklist);

    return $blocklist;
}

function atThemeList($dir="themes")
{
    $dir = AT_DIRPREFIX."themes";

	if ($handle = @opendir($dir)) {
        while (false !== ($subdir = @readdir($handle))) {
            if (@is_dir("$dir/$subdir") &&
                $subdir !== '.' &&
                $subdir !== '..' &&
                @file_exists("$dir/$subdir/theme.cfg"))
            {
                $themelist[] = $subdir;
            }
        }
        closedir($handle);
    }
    natcasesort($themelist);

    return $themelist;
}

function atModList()
{
    $umods = pnModGetUserMods();
    $amods = pnModGetAdminMods();

    $mods = array_merge((array)$amods, (array)$umods);

    $modlist = array(
        "*AdminPages",
        "*HomePage",
        "*UserPages"
    );

    foreach ($mods as $vals) {
    	if (!in_array($vals['name'], $modlist)) {
        	$modlist[] = $vals['name'];
    	}
    }
    natcasesort($modlist);

    return $modlist;
}

function atThemeSet($theme, $user=0)
{
	if (isset($theme) && @file_exists("themes/$theme/theme.cfg")) {
    	pnConfigSetVar('Default_Theme', $theme);

	    if ($user) {
			pnUserSetVar('theme', $theme);
		}
	}
}

function atGroupList()
{
	list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];

    $query = "SELECT $groupcolumn[gid], $groupcolumn[name]
              FROM $grouptable
              ORDER BY $groupcolumn[name]";

    $result = $dbconn->Execute($query);

    if ($result->EOF) {
    	return false;
    }
    while (!$result->EOF){
		list($gid, $name) = $result->fields;
		$grouplist[$gid] = $name;
		$result->MoveNext();
    }
    $result->Close();

    return $grouplist;
}

function atIsInGroup($group)
{
	$uid = pnUserGetVar('uid');

	list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
    $groupmembershiptable = $pntable['group_membership'];
    $groupmembershipcolumn = &$pntable['group_membership_column'];

    $query = "SELECT 	$groupcolumn[gid]
              FROM 		$grouptable
              WHERE 	$groupcolumn[name]='".pnVarPrepForStore($group)."'";

    $result = $dbconn->Execute($query);

    if ($result->EOF) {
    	return false;
    }
    list($gid) = $result->fields;
    $result->Close();

    $query = "SELECT 	$groupmembershipcolumn[uid]
              FROM 		$groupmembershiptable
              WHERE 	$groupmembershipcolumn[uid]=".(int)pnVarPrepForStore($uid)." AND $groupmembershipcolumn[gid]=".(int)pnVarPrepForStore($gid)."";

    $result = $dbconn->Execute($query);
    list($uid) = $result->fields;

    if ($result->EOF) {
        return false;
    }
    else {
    	$result->Close();
    	return true;
    }
}

?>
